#!/usr/bin/env ruby

require 'ruby-await-node'

ruby_await_node_runtime  = RubyAwaitNode::Runtime.new(:debug => false)
context = RubyAwaitNode::Context.new(ruby_await_node_runtime)
context.eval("global.a = 2.0")

fork_count = 4

pids = (0...fork_count).map do |i|
  fork do
    sleep i * 0.1 # simulate different process exit at different time to expose premature shutdown of shared nodejs process
    result = context.call("(function(b) { return (global.a * b); })", i)
    exit result #use the exit code to communicate the calculation result
  end
end

exit_statuses = pids.map { |pid| Process.wait2(pid) }

results = []

exit_statuses.each do |pid, status|
  results << status.exitstatus
end

# http://www.wolframalpha.com/input/?i=3rd+trianglur+number
sum = results.compact.inject(0) { |result, element| result + element }

if (sum) == 12
  exit 0
else
  exit 1
end
